diff --git a/tests/test_hub/test_get_next_release.py b/tests/test_hub/test_get_next_release.py
index 561a3f1..27a720c 100644
--- a/tests/test_hub/test_get_next_release.py
+++ b/tests/test_hub/test_get_next_release.py
@@ -7,7 +7,9 @@ import kojihub
 class TestGetNextRelease(unittest.TestCase):
 
     def setUp(self):
+        self.maxDiff = None
         self.QueryProcessor = mock.patch('kojihub.QueryProcessor').start()
+        self.get_build = mock.patch('kojihub.get_build').start()
         self._dml = mock.patch('kojihub._dml').start()
         self.query = self.QueryProcessor.return_value
         self.binfo = {'name': 'name', 'version': 'version'}
@@ -25,7 +27,7 @@ class TestGetNextRelease(unittest.TestCase):
         for n in [1, 2, 3, 5, 8, 13, 21, 34, 55]:
             self.query.executeOne.return_value = {'release': str(n)}
             result = kojihub.get_next_release(self.binfo)
-            self.assertEqual(result, str(n+1))
+            self.assertEqual(result, str(n + 1))
 
     def test_get_next_release_complex(self):
         data = [
@@ -59,10 +61,10 @@ class TestGetNextRelease(unittest.TestCase):
             # bad_incr_value
             "foo",
             None,
-            1.1,
-            {1:1},
+            {1: 1},
             [1],
         ]
         for val in data:
-            with self.assertRaises(koji.ParameterError):
+            with self.assertRaises(koji.ParameterError) as ex:
                 kojihub.get_next_release(self.binfo, incr=val)
+            self.assertEqual('incr parameter must be an integer', str(ex.exception))
diff --git a/tests/test_hub/test_get_notification_recipients.py b/tests/test_hub/test_get_notification_recipients.py
new file mode 100644
index 0000000..d6e9e86
--- /dev/null
+++ b/tests/test_hub/test_get_notification_recipients.py
@@ -0,0 +1,258 @@
+import mock
+import unittest
+
+import koji
+import kojihub
+
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
+
+class TestGetNotificationRecipients(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self.readPackageList = mock.patch('kojihub.readPackageList').start()
+        self.get_user = mock.patch('kojihub.get_user').start()
+
+        self.exports = kojihub.RootExports()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_get_notification_recipients_watchers(self):
+        # without build / tag_id
+        build = None
+        tag_id = None
+        state = koji.BUILD_STATES['CANCELED']
+
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(emails, [])
+
+        # only query to watchers
+        self.assertEqual(len(self.queries), 1)
+        q = self.queries[0]
+        self.assertEqual(q.columns, ['email', 'user_id'])
+        self.assertEqual(q.tables, ['build_notifications'])
+        self.assertEqual(q.clauses, ['package_id IS NULL',
+                                     'status = %(users_status)i',
+                                     'success_only = FALSE',
+                                     'tag_id IS NULL',
+                                     'usertype IN %(users_usertypes)s'])
+        self.assertEqual(q.joins, ['JOIN users ON build_notifications.user_id = users.id'])
+        self.assertEqual(q.values['state'], state)
+        self.assertEqual(q.values['build'], build)
+        self.assertEqual(q.values['tag_id'], tag_id)
+
+        '''
+        q = self.queries[1]
+        self.assertEqual(q.columns, ['user_id'])
+        self.assertEqual(q.tables, ['build_notifications_block'])
+        self.assertEqual(q.clauses, ['user_id IN %(user_ids)s'])
+        self.assertEqual(q.joins, [])
+        self.assertEqual(q.values['user_ids'], None)
+        '''
+        self.readPackageList.assert_not_called()
+
+    def test_get_notification_recipients_build_without_tag(self):
+        ### with build without tag
+        tag_id = None
+        state = koji.BUILD_STATES['CANCELED']
+        build = {'package_id': 12345, 'owner_name': 'owner_name', 'owner_id': 5}
+        self.queries = []
+        self.set_queries([
+            [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+            []
+        ])
+
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(emails, ['owner_name@test.domain.com'])
+
+        # there should be only query to watchers
+        self.assertEqual(len(self.queries), 2)
+        q = self.queries[0]
+        self.assertEqual(q.columns, ['email', 'user_id'])
+        self.assertEqual(q.tables, ['build_notifications'])
+        self.assertEqual(q.clauses, ['package_id = %(package_id)i OR package_id IS NULL',
+                                     'status = %(users_status)i',
+                                     'success_only = FALSE',
+                                     'tag_id IS NULL',
+                                     'usertype IN %(users_usertypes)s'])
+        self.assertEqual(q.joins, ['JOIN users ON build_notifications.user_id = users.id'])
+        self.assertEqual(q.values['package_id'], build['package_id'])
+        self.assertEqual(q.values['state'], state)
+        self.assertEqual(q.values['build'], build)
+        self.assertEqual(q.values['tag_id'], tag_id)
+
+        q = self.queries[1]
+        self.assertEqual(q.columns, ['user_id'])
+        self.assertEqual(q.tables, ['build_notifications_block'])
+        self.assertEqual(q.clauses, ['package_id = %(package_id)i OR package_id IS NULL',
+                                     'tag_id IS NULL',
+                                     'user_id IN %(user_ids)s',
+                                     ])
+        self.assertEqual(q.joins, None)
+        self.assertEqual(q.values['user_ids'], [5])
+
+        self.readPackageList.assert_not_called()
+
+    def test_get_notification_recipients_tag_without_build(self):
+        ### with tag without build makes no sense
+        build = None
+        tag_id = 123
+        state = koji.BUILD_STATES['CANCELED']
+        self.queries = []
+
+        with self.assertRaises(koji.GenericError):
+            kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(self.queries, [])
+        self.readPackageList.assert_not_called()
+
+    def set_queries(self, return_values):
+        self.query_returns = return_values
+        self.query_returns.reverse()
+
+        def getQuery(*args, **kwargs):
+            q = QP(*args, **kwargs)
+            q.execute = mock.MagicMock()
+            q.execute.return_value = self.query_returns.pop()
+            self.queries.append(q)
+            return q
+        self.QueryProcessor.side_effect = getQuery
+
+    def test_get_notification_recipients_tag_with_build(self):
+        ### with tag and build
+        build = {'package_id': 12345, 'owner_name': 'owner_name', 'owner_id': 5}
+        tag_id = 123
+        state = koji.BUILD_STATES['CANCELED']
+        self.readPackageList.return_value = {12345: {'blocked': False, 'owner_id': 'owner_id'}}
+        self.get_user.return_value = {
+            'id': 342,
+            'name': 'pkg_owner_name',
+            'status': koji.USER_STATUS['NORMAL'],
+            'usertype': koji.USERTYPES['NORMAL']
+        }
+        self.set_queries([
+            [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+            []
+        ])
+
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(sorted(emails),
+                         ['owner_name@test.domain.com', 'pkg_owner_name@test.domain.com'])
+
+        # there should be only query to watchers
+        self.assertEqual(len(self.queries), 2)
+        q = self.queries[0]
+        self.assertEqual(q.columns, ['email', 'user_id'])
+        self.assertEqual(q.tables, ['build_notifications'])
+        self.assertEqual(q.clauses, ['package_id = %(package_id)i OR package_id IS NULL',
+                                     'status = %(users_status)i',
+                                     'success_only = FALSE',
+                                     'tag_id = %(tag_id)i OR tag_id IS NULL',
+                                     'usertype IN %(users_usertypes)s',
+                                     ])
+        self.assertEqual(q.joins, ['JOIN users ON build_notifications.user_id = users.id'])
+        self.assertEqual(q.values['package_id'], build['package_id'])
+        self.assertEqual(q.values['state'], state)
+        self.assertEqual(q.values['build'], build)
+        self.assertEqual(q.values['tag_id'], tag_id)
+
+        q = self.queries[1]
+        self.assertEqual(q.columns, ['user_id'])
+        self.assertEqual(q.tables, ['build_notifications_block'])
+        self.assertEqual(q.clauses, ['package_id = %(package_id)i OR package_id IS NULL',
+                                     'tag_id = %(tag_id)i OR tag_id IS NULL',
+                                     'user_id IN %(user_ids)s',
+                                     ])
+        self.assertEqual(q.joins, None)
+        self.assertEqual(sorted(q.values['user_ids']), [5, 342])
+        self.readPackageList.assert_called_once_with(
+            pkgID=build['package_id'], tagID=tag_id, inherit=True)
+        self.get_user.asssert_called_once_with(342, strict=True)
+
+    def test_get_notification_recipients_blocked_pkg_owner(self):
+        # blocked package owner
+        build = {'package_id': 12345, 'owner_name': 'owner_name', 'owner_id': 5}
+        tag_id = 123
+        state = koji.BUILD_STATES['CANCELED']
+        self.get_user.return_value = {
+            'id': 342,
+            'name': 'pkg_owner_name',
+            'status': koji.USER_STATUS['BLOCKED'],
+            'usertype': koji.USERTYPES['NORMAL']
+        }
+        self.set_queries([
+            [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+            []
+        ])
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(emails, ['owner_name@test.domain.com'])
+
+    def test_get_notification_recipients_optout(self):
+        # blocked package owner
+        build = {'package_id': 12345, 'owner_name': 'owner_name', 'owner_id': 5}
+        tag_id = 123
+        state = koji.BUILD_STATES['CANCELED']
+        self.get_user.return_value = {
+            'id': 342,
+            'name': 'pkg_owner_name',
+            'status': koji.USER_STATUS['NORMAL'],
+            'usertype': koji.USERTYPES['NORMAL']
+        }
+        self.set_queries([
+            [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+            [{'user_id': 5}]
+        ])
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(emails, [])
+
+    def test_get_notification_recipients_machine(self):
+        # package owner is machine
+        build = {'package_id': 12345, 'owner_name': 'owner_name', 'owner_id': 5}
+        tag_id = 123
+        state = koji.BUILD_STATES['CANCELED']
+        self.get_user.return_value = {
+            'id': 342,
+            'name': 'pkg_owner_name',
+            'status': koji.USER_STATUS['NORMAL'],
+            'usertype': koji.USERTYPES['HOST']
+        }
+        self.set_queries([
+            [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+            []
+        ])
+        emails = kojihub.get_notification_recipients(build, tag_id, state)
+        self.assertEqual(emails, ['owner_name@test.domain.com'])
diff --git a/tests/test_hub/test_grant_permissions.py b/tests/test_hub/test_grant_permissions.py
index 3745b4a..d8371ba 100644
--- a/tests/test_hub/test_grant_permissions.py
+++ b/tests/test_hub/test_grant_permissions.py
@@ -122,3 +122,13 @@ class TestGrantPermission(unittest.TestCase):
         self.assertEqual(ip.table, 'user_perms')
         self.assertEqual(ip.rawdata, {})
         self.context.session.assertPerm.assert_called_with('admin')
+
+    def test_grant_permission_description_wrong_type(self):
+        description = ['test-description']
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.grantPermission(self.user_name, self.perms_name,
+                                         description=description, create=True)
+        self.assertEqual(f"Invalid type for value '{description}': {type(description)}",
+                         str(ex.exception))
+        self.insert_processor.assert_not_called()
+        self.context.session.assertPerm.assert_called_with('admin')
diff --git a/tests/test_hub/test_import_archive.py b/tests/test_hub/test_import_archive.py
new file mode 100644
index 0000000..2a6719d
--- /dev/null
+++ b/tests/test_hub/test_import_archive.py
@@ -0,0 +1,40 @@
+import mock
+import unittest
+import koji
+import kojihub
+
+
+class TestImportArchive(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertPerm = mock.MagicMock()
+        self.filepath = 'path/to/file'
+        self.buildinfo = 'build-1-1.4'
+        self.type_archive = 'maven'
+        self.typeinfo = {'group_id': 1, 'artifact_id': 2, 'version': 1}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_maven_not_enabled(self):
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.importArchive(self.filepath, self.buildinfo, self.type_archive,
+                                       self.typeinfo)
+        self.assertEqual("Maven support not enabled", str(cm.exception))
+
+    def test_win_not_enabled(self):
+        type_archive = 'win'
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.importArchive(self.filepath, self.buildinfo, type_archive, self.typeinfo)
+        self.assertEqual("Windows support not enabled", str(cm.exception))
+
+    def test_unsupported_type(self):
+        type_archive = 'test-type'
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.importArchive(self.filepath, self.buildinfo, type_archive, self.typeinfo)
+        self.assertEqual(f"unsupported archive type: {type_archive}", str(cm.exception))
diff --git a/tests/test_hub/test_import_archive_internal.py b/tests/test_hub/test_import_archive_internal.py
new file mode 100644
index 0000000..70f64ba
--- /dev/null
+++ b/tests/test_hub/test_import_archive_internal.py
@@ -0,0 +1,23 @@
+import unittest
+import mock
+
+import koji
+import kojihub
+
+
+class TestImportArchiveInternal(unittest.TestCase):
+    def setUp(self):
+        self.os_path_exists = mock.patch('os.path.exists').start()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_import_archive_internal_non_exist_filepath(self):
+        self.os_path_exists.return_value = False
+        filepath = 'test/file/path/to/archive'
+        buildinfo = {'id': 1, 'name': 'test-build'}
+        type_archive = 'maven'
+        typeInfo = {'group_id': 1, 'artifact_id': 2, 'version': 3}
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.import_archive_internal(filepath, buildinfo, type_archive, typeInfo)
+        self.assertEqual(f"No such file: {filepath}", str(cm.exception))
diff --git a/tests/test_hub/test_import_build.py b/tests/test_hub/test_import_build.py
index 0f18a03..5de5a7a 100644
--- a/tests/test_hub/test_import_build.py
+++ b/tests/test_hub/test_import_build.py
@@ -1,203 +1,13 @@
 import copy
 import mock
+import unittest
 import shutil
 import tempfile
-import unittest
 
 import koji
 import kojihub
 
 
-class TestImportRPM(unittest.TestCase):
-    def setUp(self):
-        self.tempdir = tempfile.mkdtemp()
-        self.filename = self.tempdir + "/name-version-release.arch.rpm"
-        # Touch a file
-        with open(self.filename, 'w'):
-            pass
-        self.src_filename = self.tempdir + "/name-version-release.src.rpm"
-        # Touch a file
-        with open(self.src_filename, 'w'):
-            pass
-        self.context = mock.patch('kojihub.context').start()
-        self.cursor = mock.MagicMock()
-
-        self.rpm_header_retval = {
-            'filename': 'name-version-release.arch.rpm',
-            'sourcepackage': 2,
-            1000: 'name',
-            1001: 'version',
-            1002: 'release',
-            1003: 'epoch',
-            1006: 'buildtime',
-            1022: 'arch',
-            1044: 'name-version-release.arch',
-            1106: 'sourcepackage',
-            261: 'payload hash',
-        }
-
-    def tearDown(self):
-        shutil.rmtree(self.tempdir)
-
-    def test_nonexistant_rpm(self):
-        with self.assertRaises(koji.GenericError):
-            kojihub.import_rpm("this does not exist")
-
-    @mock.patch('kojihub.get_build')
-    @mock.patch('koji.get_rpm_header')
-    def test_import_rpm_failed_build(self, get_rpm_header, get_build):
-        get_rpm_header.return_value = self.rpm_header_retval
-        get_build.return_value = {
-            'state': koji.BUILD_STATES['FAILED'],
-            'name': 'name',
-            'version': 'version',
-            'release': 'release',
-        }
-        with self.assertRaises(koji.GenericError):
-            kojihub.import_rpm(self.filename)
-
-    @mock.patch('kojihub.new_typed_build')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub._singleValue')
-    @mock.patch('kojihub.get_build')
-    @mock.patch('koji.get_rpm_header')
-    def test_import_rpm_completed_build(self, get_rpm_header, get_build,
-                                        _singleValue, _dml,
-                                        new_typed_build):
-        get_rpm_header.return_value = self.rpm_header_retval
-        get_build.return_value = {
-            'state': koji.BUILD_STATES['COMPLETE'],
-            'name': 'name',
-            'version': 'version',
-            'release': 'release',
-            'id': 12345,
-        }
-        _singleValue.return_value = 9876
-        kojihub.import_rpm(self.filename)
-        fields = [
-            'arch',
-            'build_id',
-            'buildroot_id',
-            'buildtime',
-            'epoch',
-            'external_repo_id',
-            'id',
-            'name',
-            'payloadhash',
-            'release',
-            'size',
-            'version',
-        ]
-        statement = 'INSERT INTO rpminfo (%s) VALUES (%s)' % (
-            ", ".join(fields),
-            ", ".join(['%%(%s)s' % field for field in fields])
-        )
-        values = {
-            'build_id': 12345,
-            'name': 'name',
-            'arch': 'arch',
-            'buildtime': 'buildtime',
-            'payloadhash': '7061796c6f61642068617368',
-            'epoch': 'epoch',
-            'version': 'version',
-            'buildroot_id': None,
-            'release': 'release',
-            'external_repo_id': 0,
-            'id': 9876,
-            'size': 0,
-        }
-        _dml.assert_called_once_with(statement, values)
-
-    @mock.patch('kojihub.new_typed_build')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub._singleValue')
-    @mock.patch('kojihub.get_build')
-    @mock.patch('koji.get_rpm_header')
-    def test_import_rpm_completed_source_build(self, get_rpm_header, get_build,
-                                               _singleValue, _dml,
-                                               new_typed_build):
-        retval = copy.copy(self.rpm_header_retval)
-        retval.update({
-            'filename': 'name-version-release.arch.rpm',
-            1044: 'name-version-release.src',
-            1022: 'src',
-            1106: 1,
-        })
-        get_rpm_header.return_value = retval
-        get_build.return_value = {
-            'state': koji.BUILD_STATES['COMPLETE'],
-            'name': 'name',
-            'version': 'version',
-            'release': 'release',
-            'id': 12345,
-        }
-        _singleValue.return_value = 9876
-        kojihub.import_rpm(self.src_filename)
-        fields = [
-            'arch',
-            'build_id',
-            'buildroot_id',
-            'buildtime',
-            'epoch',
-            'external_repo_id',
-            'id',
-            'name',
-            'payloadhash',
-            'release',
-            'size',
-            'version',
-        ]
-        statement = 'INSERT INTO rpminfo (%s) VALUES (%s)' % (
-            ", ".join(fields),
-            ", ".join(['%%(%s)s' % field for field in fields])
-        )
-        values = {
-            'build_id': 12345,
-            'name': 'name',
-            'arch': 'src',
-            'buildtime': 'buildtime',
-            'payloadhash': '7061796c6f61642068617368',
-            'epoch': 'epoch',
-            'version': 'version',
-            'buildroot_id': None,
-            'release': 'release',
-            'external_repo_id': 0,
-            'id': 9876,
-            'size': 0,
-        }
-        _dml.assert_called_once_with(statement, values)
-
-    @mock.patch('os.path.exists')
-    def test_non_exist_file(self, os_path_exist):
-        exports = kojihub.RootExports()
-        basename = 'rpm-1-34'
-        uploadpath = koji.pathinfo.work()
-        filepath = '%s/%s/%s' % (uploadpath, self.filename, basename)
-        os_path_exist.return_value = False
-        with self.assertRaises(koji.GenericError) as cm:
-            exports.importRPM(self.filename, basename)
-        self.assertEqual("No such file: %s" % filepath, str(cm.exception))
-
-    @mock.patch('koji.get_rpm_header')
-    @mock.patch('os.path.exists')
-    @mock.patch('os.path.basename')
-    def test_non_exist_file(self, os_path_basename, os_path_exist, get_rpm_header):
-        self.cursor.fetchone.return_value = None
-        self.context.cnx.cursor.return_value = self.cursor
-        retval = copy.copy(self.rpm_header_retval)
-        retval.update({
-            'filename': 'name-version-release.arch.rpm',
-            'sourcepackage': 2
-        })
-        get_rpm_header.return_value = retval
-        os_path_exist.return_value = True
-        os_path_basename.return_value = 'name-version-release.arch.rpm'
-        kojihub.get_build.return_value = None
-        with self.assertRaises(koji.GenericError) as cm:
-            kojihub.import_rpm(self.src_filename)
-        self.assertEqual("No such build", str(cm.exception))
-
-
 class TestImportBuild(unittest.TestCase):
     def setUp(self):
         self.tempdir = tempfile.mkdtemp()
@@ -210,6 +20,22 @@ class TestImportBuild(unittest.TestCase):
         with open(self.src_filename, 'w'):
             pass
 
+        self.check_volume_policy = mock.patch('kojihub.check_volume_policy').start()
+        self.new_typed_build = mock.patch('kojihub.new_typed_build').start()
+        self._dml = mock.patch('kojihub._dml').start()
+        self._singleValue = mock.patch('kojihub._singleValue').start()
+        self.get_build = mock.patch('kojihub.get_build').start()
+        self.add_rpm_sig = mock.patch('kojihub.add_rpm_sig').start()
+        self.rip_rpm_sighdr = mock.patch('koji.rip_rpm_sighdr').start()
+        self.import_rpm_file = mock.patch('kojihub.import_rpm_file').start()
+        self.import_rpm = mock.patch('kojihub.import_rpm').start()
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor').start()
+        self.context = mock.patch('kojihub.context').start()
+        self.new_package = mock.patch('kojihub.new_package').start()
+        self.get_rpm_header = mock.patch('koji.get_rpm_header').start()
+        self.pathinfo_work = mock.patch('koji.pathinfo.work').start()
+        self.os_path_exists = mock.patch('os.path.exists').start()
+
         self.rpm_header_retval = {
             'filename': 'name-version-release.arch.rpm',
             1000: 'name',
@@ -225,39 +51,21 @@ class TestImportBuild(unittest.TestCase):
 
     def tearDown(self):
         shutil.rmtree(self.tempdir)
+        mock.patch.stopall()
 
-    @mock.patch('kojihub.check_volume_policy')
-    @mock.patch('kojihub.new_typed_build')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub._singleValue')
-    @mock.patch('kojihub.get_build')
-    @mock.patch('kojihub.add_rpm_sig')
-    @mock.patch('koji.rip_rpm_sighdr')
-    @mock.patch('kojihub.import_rpm_file')
-    @mock.patch('kojihub.import_rpm')
-    @mock.patch('kojihub.QueryProcessor')
-    @mock.patch('kojihub.context')
-    @mock.patch('kojihub.new_package')
-    @mock.patch('koji.get_rpm_header')
-    @mock.patch('koji.pathinfo.work')
-    def test_import_build_completed_build(self, work, get_rpm_header,
-                                          new_package, context, query,
-                                          import_rpm, import_rpm_file,
-                                          rip_rpm_sighdr, add_rpm_sig,
-                                          get_build, _singleValue, _dml,
-                                          new_typed_build, check_volume_policy):
+    def test_import_build_completed_build(self):
 
-        rip_rpm_sighdr.return_value = (0, 0)
+        self.rip_rpm_sighdr.return_value = (0, 0)
 
         processor = mock.MagicMock()
         processor.executeOne.return_value = None
-        query.return_value = processor
+        self.QueryProcessor.return_value = processor
 
-        context.session.user_id = 99
+        self.context.session.user_id = 99
 
-        work.return_value = '/'
+        self.pathinfo_work.return_value = '/'
 
-        check_volume_policy.return_value = {'id':0, 'name': 'DEFAULT'}
+        self.check_volume_policy.return_value = {'id': 0, 'name': 'DEFAULT'}
 
         retval = copy.copy(self.rpm_header_retval)
         retval.update({
@@ -266,7 +74,7 @@ class TestImportBuild(unittest.TestCase):
             1022: 'src',
             1106: 1,
         })
-        get_rpm_header.return_value = retval
+        self.get_rpm_header.return_value = retval
         binfo = {
             'state': koji.BUILD_STATES['COMPLETE'],
             'name': 'name',
@@ -277,7 +85,7 @@ class TestImportBuild(unittest.TestCase):
         # get_build called once to check for existing,
         # if it doesn't exist, called another time after creating
         # then 3rd later to get the build info
-        get_build.side_effect = [None, binfo, binfo]
+        self.get_build.side_effect = [None, binfo, binfo]
 
         kojihub.import_build(self.src_filename, [self.filename])
 
@@ -315,13 +123,29 @@ class TestImportBuild(unittest.TestCase):
             'pkg_id': mock.ANY,
             'id': mock.ANY,
         }
-        _dml.assert_called_once_with(statement, values)
+        self._dml.assert_called_once_with(statement, values)
 
-    @mock.patch('os.path.exists')
-    def test_import_build_non_exist_file(self, os_path_exists):
+    def test_import_build_non_exist_file(self):
         uploadpath = koji.pathinfo.work()
-        os_path_exists.return_value = False
+        self.os_path_exists.return_value = False
         with self.assertRaises(koji.GenericError) as cm:
             kojihub.import_build(self.src_filename, [self.filename])
-        self.assertEqual("No such file: %s/%s" % (uploadpath, self.src_filename),
+        self.assertEqual(f"No such file: {uploadpath}/{self.src_filename}", str(cm.exception))
+
+    def test_import_build_wrong_type_brmap(self):
+        brmap = 'test-brmap'
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.import_build(self.src_filename, [self.filename], brmap=brmap)
+        self.assertEqual(f"Invalid type for value '{brmap}': {type(brmap)}", str(cm.exception))
+
+    def test_import_build_wrong_type_srpm(self):
+        srpm = ['test-srpm']
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.import_build(srpm, [self.filename])
+        self.assertEqual(f"Invalid type for value '{srpm}': {type(srpm)}", str(cm.exception))
+
+    def test_import_build_wrong_type_rpms(self):
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.import_build(self.src_filename, self.filename)
+        self.assertEqual(f"Invalid type for value '{self.filename}': {type(self.filename)}",
                          str(cm.exception))
